@echo off
setlocal DISABLEDELAYEDEXPANSION
setlocal ENABLEDELAYEDEXPANSION
if exist _deploy.cmd echo. & echo This script must be run from a deployement. & pause>nul & goto :eof

where /Q curl.exe
if errorlevel 1 (
	echo. & echo Failed to find the cURL utility.
	echo. Install curl.exe from https://curl.se/windows/curl-win32-latest.zip
	echo. & pause>nul & goto :eof
)

set app=ATB Tester
set filelist=.package

set JFROG_SRC=!app: =_!
set JFROG_AUTH=user:MEXvVnB99nQhn88V
set JFROG_URL=https://westline.jfrog.io/artifactory
set JFROG_REPO=apps-generic-local

set rooturl=%JFROG_URL%/%JFROG_REPO%/%JFROG_SRC%


:: Get the folder name.
set d=%~p0
set d=!d:"=!
set d=!d: =#!
set d=!d:\=,!
for %%p in (!d!) do @set folder=%%p
set folder=!folder:#= !


:: Get the current version number.
set VER=
if exist "!app!.lua" for /f "tokens=1,2,3 delims=; " %%j in ('type "!app!.lua" ^| find "Version"') do if "%%j" equ "Version" set VER=%%~l


:: Download the file list.
echo. & echo Downloading the file list from !rooturl!...
curl -kL --progress-bar -u "%JFROG_AUTH%" -O !rooturl!/!filelist!
if errorlevel 1 goto :err-filelist


:: Make backups.
if exist Macros.lua.bak del /Q Macros.lua.bak
if exist Macros.lua ren Macros.lua Macros.lua.bak

if "%VER%" equ "" goto :download
where /Q 7za.exe
if errorlevel 1 goto :download
if not exist .backup md .backup
if exist ".backup\%JFROG_SRC%-%VER%.zip" del /Q ".backup\%JFROG_SRC%-%VER%.zip"
setlocal DISABLEDELAYEDEXPANSION
7za a -r -ssw -x!.* -x!*\.* -x!.*\ -x!*\.*\ ".backup\%JFROG_SRC%-%VER%.zip" *
setlocal ENABLEDELAYEDEXPANSION


:download
echo. & echo Ready to overwrite !folder! from !rooturl!.
echo. & pause

:: Download the files in the file list.
set app=
set ver=
set /a line = 0
for /f "delims=" %%f in (!filelist!) do (
	set /a line += 1
	if !line! equ 1 (set app=%%f
	) else if !line! equ 2 (set ver=%%f
	) else if !line! equ 3 if "%%f" neq "!filelist!" goto :err-filelist
)
echo. & echo. & echo Updating %app% %ver%... & echo ------------------------------------------------------------------------

for /f "skip=4 delims=" %%f in (!filelist!) do (
	echo. & echo Downloading %%f...
	set file=%%f
	set file=!file: =%%20!
	set url=!rooturl!/!file!
	set url=!url:\=/!
	curl -kL --create-dirs --progress-bar -u "%JFROG_AUTH%" -o "%%f" "!url!"
)
if exist "!filelist!" del /Q/F "!filelist!">nul


:: Finalize the update.
if not exist .data   md .data
if not exist .config md .config
if not exist "!app!.ini" if exist "!app!.def.ini" ren "!app!.def.ini" "!app!.ini"
if exist "!app!.def.ini" del /Q/F "!app!.def.ini">nul
goto :done


:err-filelist
echo. & echo Failed to download the file list.
goto :done

:done
echo. & pause & goto :eof
